#!/usr/bin/env python

# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 3
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; If not, see <http://www.gnu.org/licenses/>.
#
# Copyright 2021 CELLS / ALBA Synchrotron, Cerdanyola del Valles, Spain
#
# ##### END GPL LICENSE BLOCK #####


from about import monkey_patch_about_action
from constants import version
from panel import DllrfPanel
import pathlib
from taurus import tauruscustomsettings
from taurus.qt.qtgui.application import TaurusApplication
from taurus_pyqtgraph import TaurusTrend
from taurus.qt.qtgui.taurusgui import TaurusGui


def main():
    app_name = f"Digital Low Level Radio Frequency"
    app = TaurusApplication(
            cmd_line_parser=None,
            app_name=app_name,
            app_version=version,
            org_name='Alba'
    )
    tauruscustomsettings.ORGANIZATION_LOGO = \
        f"{pathlib.Path(__file__).parent.absolute()}/imgs/alba_logo.jpg"
    gui = TaurusGui(confname=f"{pathlib.Path(__file__).parent.absolute()}/"
                             f"Digital Low Level Radio Frequency.py")
    monkey_patch_about_action(gui,
                              csv_version='1.0.12',
                              codegen_version='1.0.15',
                              device_name='bessy/rf/struck-01')
    panels = {
        'Settings': [
            'bessy/rf/struck-01/FreqSquare',
            'bessy/rf/struck-01/Automatic_Startup_Enable',
            'bessy/rf/struck-01/Gain_IOT1',
            'bessy/rf/struck-01/Gain_IOT2',
            'bessy/rf/struck-01/Gain_OL',
            'bessy/rf/struck-01/Mixers_Output_Enable',
            'bessy/rf/struck-01/LoopInput',
            'bessy/rf/struck-01/Phase_Shift_FwCav',
            'bessy/rf/struck-01/Phase_Shift_FwIOT1',
            'bessy/rf/struck-01/Phase_Shift_FwIOT2',
            'bessy/rf/struck-01/Amp_PhSh_FwCav',
            'bessy/rf/struck-01/Amp_PhSh_FwIOT1',
            'bessy/rf/struck-01/Amp_PhSh_FwIOT2',
            'bessy/rf/struck-01/FwMin_Amp_and_Ph',
            'bessy/rf/struck-01/FwMin_slave',
            'bessy/rf/struck-01/FDL_Sw_TRG',
            'bessy/rf/struck-01/FDL_Trg_Reset',
            'bessy/rf/struck-01/ramp_enable',
            'bessy/rf/struck-01/PhaseShift_Enable',
            'bessy/rf/struck-01/DACs_Phase_Shift_enable',
            'bessy/rf/struck-01/SquareRef_enable',
            'bessy/rf/struck-01/ResetKi',
            'bessy/rf/struck-01/Look_ref',
            'bessy/rf/struck-01/Quadrant_Selection',
            'bessy/rf/struck-01/PI_Slave_diags_Enable',
            'bessy/rf/struck-01/PI_slave_Loop_input_selection',
            'bessy/rf/struck-01/PILimitSlave',
            'bessy/rf/struck-01/reset_adac_trig_NOK_State',
            'bessy/rf/struck-01/PhCorrectionControl_enable',
            'bessy/rf/struck-01/MOPhDriftComp',
            'bessy/rf/struck-01/MOPhDriftCompPos',
            'bessy/rf/struck-01/MOPhDriftCompGain',
            'bessy/rf/struck-01/Automatic_Conditioning_enable',
            'bessy/rf/struck-01/Delay_trigger_outputs',
            'bessy/rf/struck-01/FieldFlatness',
            'bessy/rf/struck-01/FieldFlatnessPos',
            'bessy/rf/struck-01/FieldFlatPercentage',
            'bessy/rf/struck-01/AmpCell2Gain',
            'bessy/rf/struck-01/AmpCell4Gain',
            'bessy/rf/struck-01/t1_ramping',
            'bessy/rf/struck-01/t2_ramping',
            'bessy/rf/struck-01/t3_ramping',
            'bessy/rf/struck-01/t4_ramping',
            'bessy/rf/struck-01/AmpRampInit',
            'bessy/rf/struck-01/AmpRampEnd',
            'bessy/rf/struck-01/PhaseRampInit',
            'bessy/rf/struck-01/PhaseRampEnd',
            'bessy/rf/struck-01/BottomRampDiagEnable',
            'bessy/rf/struck-01/MovePlg2',
            'bessy/rf/struck-01/Steps_to_detune_cavity_after_trip',
            'bessy/rf/struck-01/Automatic_Parking_disable',
            'bessy/rf/struck-01/Parkup_Enable',
            'bessy/rf/struck-01/Offset_steps_to_unpark_cavity',
            'bessy/rf/struck-01/Phase_Offset_Robinson',
            'bessy/rf/struck-01/Freq_Mod_Enable',
            'bessy/rf/struck-01/Modulation_frequency',
            'bessy/rf/struck-01/Amplitude_of_Amplitude_Modulation',
            'bessy/rf/struck-01/Phase_Delay_for_Amp_Mod',
            'bessy/rf/struck-01/Freq_Mod_compensation_after_trip',
            'bessy/rf/struck-01/Time_delay',
            'bessy/rf/struck-01/Modulation_type',
            'bessy/rf/struck-01/Amplitude_of_Phase_Modulation',
            'bessy/rf/struck-01/PhShControl1',
            'bessy/rf/struck-01/PhShControl2',
            'bessy/rf/struck-01/Absolute_Time_Decay',
            'bessy/rf/struck-01/Positive_Phase_Modulation',
            'bessy/rf/struck-01/Phase_Step_Modulation',
        ],
        'Diags': [
            'bessy/rf/struck-01/Ierror1',
            'bessy/rf/struck-01/Qerror1',
            'bessy/rf/struck-01/IErrorAccum1',
            'bessy/rf/struck-01/QErrorAccum1',
            'bessy/rf/struck-01/AngCavFw1',
            'bessy/rf/struck-01/AngCav1',
            'bessy/rf/struck-01/AngFw1',
            'bessy/rf/struck-01/IFwLoad',
            'bessy/rf/struck-01/QFwLoad',
            'bessy/rf/struck-01/IControl1',
            'bessy/rf/struck-01/QControl1',
            'bessy/rf/struck-01/IControl2',
            'bessy/rf/struck-01/QControl2',
            'bessy/rf/struck-01/FFError',
            'bessy/rf/struck-01/AmpCell2',
            'bessy/rf/struck-01/AmpCell4',
            'bessy/rf/struck-01/IFwSSA1',
            'bessy/rf/struck-01/QFwSSA1',
            'bessy/rf/struck-01/IRvSSA1',
            'bessy/rf/struck-01/QRvSSA1',
            'bessy/rf/struck-01/IFwSSA2',
            'bessy/rf/struck-01/QFwSSA2',
            'bessy/rf/struck-01/IRvSSA2',
            'bessy/rf/struck-01/QRvSSA2',
            'bessy/rf/struck-01/IFwCircIn',
            'bessy/rf/struck-01/QFwCircIn',
            'bessy/rf/struck-01/IFwCircOut',
            'bessy/rf/struck-01/QFwCircOut',
            'bessy/rf/struck-01/IRvCircOut',
            'bessy/rf/struck-01/QRvCircOut',
            'bessy/rf/struck-01/IRvCircIn',
            'bessy/rf/struck-01/QRvCircIn',
            'bessy/rf/struck-01/IRvIOT1',
            'bessy/rf/struck-01/QRvIOT1',
            'bessy/rf/struck-01/IRvIOT2',
            'bessy/rf/struck-01/QRvIOT2',
            'bessy/rf/struck-01/AmpDACsIFIn',
            'bessy/rf/struck-01/PhaseDACsIFIn',
            'bessy/rf/struck-01/PhaseLatency_Error',
            'bessy/rf/struck-01/PhaseLatency_Control',
            'bessy/rf/struck-01/PhShFwIOT1_sig',
            'bessy/rf/struck-01/PhShFwIOT2_sig',
            'bessy/rf/struck-01/IDACsIFIn',
            'bessy/rf/struck-01/QDACsIFIn',
            'bessy/rf/struck-01/IFwCav_PhSh',
            'bessy/rf/struck-01/QFwCav_PhSh',
            'bessy/rf/struck-01/IFwIOT1_PhSh',
            'bessy/rf/struck-01/QFwIOT1_PhSh',
            'bessy/rf/struck-01/IFwIOT2_PhSh',
            'bessy/rf/struck-01/QFwIOT2_PhSh',
            'bessy/rf/struck-01/FwMinAmpPhLoop',
            'bessy/rf/struck-01/SlavePI_Input_I',
            'bessy/rf/struck-01/slavePI_Input_Q',
            'bessy/rf/struck-01/SlavePI_Ref_I',
            'bessy/rf/struck-01/SlavePI_Ref_Q',
            'bessy/rf/struck-01/SlavePI_controlOut_I1',
            'bessy/rf/struck-01/SlavePI_controlOut_Q1',
            'bessy/rf/struck-01/SlavePI_controlOut_I2',
            'bessy/rf/struck-01/SlavePI_controlOut_Q2',
            'bessy/rf/struck-01/IntLimitSlave',
            'bessy/rf/struck-01/FwMinAmpPhSlaveLoop',
            'bessy/rf/struck-01/PulseUp_out',
            'bessy/rf/struck-01/IRampInitRef',
            'bessy/rf/struck-01/QRampInitRef',
            'bessy/rf/struck-01/IRampInitCav',
            'bessy/rf/struck-01/QRampInitCav',
            'bessy/rf/struck-01/IRampInitError',
            'bessy/rf/struck-01/QRampInitError',
            'bessy/rf/struck-01/IRampInitErrorAccum',
            'bessy/rf/struck-01/QRampInitErrorAccum',
            'bessy/rf/struck-01/IRampInitControl',
            'bessy/rf/struck-01/QRampInitControl',
            'bessy/rf/struck-01/IRampEndRef',
            'bessy/rf/struck-01/QRampEndRef',
            'bessy/rf/struck-01/IRampEndCav',
            'bessy/rf/struck-01/QRampEndCav',
            'bessy/rf/struck-01/IRampEndError',
            'bessy/rf/struck-01/QRampEndError',
            'bessy/rf/struck-01/IRampEndErrorAccum',
            'bessy/rf/struck-01/QRampEndErrorAccum',
            'bessy/rf/struck-01/IRampEndControl',
            'bessy/rf/struck-01/QRampEndControl',
            'bessy/rf/struck-01/IFwInit',
            'bessy/rf/struck-01/QFwInit',
            'bessy/rf/struck-01/ICell2Init',
            'bessy/rf/struck-01/QCell2Init',
            'bessy/rf/struck-01/ICell4Init',
            'bessy/rf/struck-01/QCell4Init',
            'bessy/rf/struck-01/IFwLoadInit',
            'bessy/rf/struck-01/QFwLoadInit',
            'bessy/rf/struck-01/IRvCavINit',
            'bessy/rf/struck-01/QRvCavInit',
            'bessy/rf/struck-01/IFwTx1Init',
            'bessy/rf/struck-01/QFwTx1init',
            'bessy/rf/struck-01/IRvTx1Init',
            'bessy/rf/struck-01/QRvTx1init',
            'bessy/rf/struck-01/IFwCircinInit',
            'bessy/rf/struck-01/QFwcircInInit',
            'bessy/rf/struck-01/IFwCircOutInit',
            'bessy/rf/struck-01/QFwCircOutInit',
            'bessy/rf/struck-01/IRvCircOutInit',
            'bessy/rf/struck-01/QRvCircOutInit',
            'bessy/rf/struck-01/IRvCircInInit',
            'bessy/rf/struck-01/QRvCircInInit',
            'bessy/rf/struck-01/IFwEnd',
            'bessy/rf/struck-01/QFwEnd',
            'bessy/rf/struck-01/ICell2End',
            'bessy/rf/struck-01/QCell2End',
            'bessy/rf/struck-01/ICell4End',
            'bessy/rf/struck-01/QCell4End',
            'bessy/rf/struck-01/IFwLoadEnd',
            'bessy/rf/struck-01/QFwLoadEnd',
            'bessy/rf/struck-01/IRvCavEnd',
            'bessy/rf/struck-01/QRvCavEnd',
            'bessy/rf/struck-01/IFwTx1End',
            'bessy/rf/struck-01/QFwTx1End',
            'bessy/rf/struck-01/IRvTx1End',
            'bessy/rf/struck-01/QRvTx1End',
            'bessy/rf/struck-01/IFwCircinEnd',
            'bessy/rf/struck-01/QFwcircInEnd',
            'bessy/rf/struck-01/IFwCircOutEnd',
            'bessy/rf/struck-01/QFwCircOutEnd',
            'bessy/rf/struck-01/IRvCircOutEnd',
            'bessy/rf/struck-01/QRvCircOutEnd',
            'bessy/rf/struck-01/IRvCircInEnd',
            'bessy/rf/struck-01/QRvCircInEnd',
            'bessy/rf/struck-01/1HzTRGDiag',
            'bessy/rf/struck-01/3HzTRGDiag',
            'bessy/rf/struck-01/AmpCell2FFInit',
            'bessy/rf/struck-01/AmpCell4FFInit',
            'bessy/rf/struck-01/FFErrorInit',
            'bessy/rf/struck-01/AmpCell2FFEnd',
            'bessy/rf/struck-01/AmpCell4FFEnd',
            'bessy/rf/struck-01/StateStart',
            'bessy/rf/struck-01/TuningOn',
            'bessy/rf/struck-01/ForwardMin_tuning',
            'bessy/rf/struck-01/FwAmp',
            'bessy/rf/struck-01/CavAmp',
            'bessy/rf/struck-01/FFOn',
            'bessy/rf/struck-01/Conditioning_Duty_cycle_old',
            'bessy/rf/struck-01/FwMinAmpPhdiags',
            'bessy/rf/struck-01/cavity_parked',
            'bessy/rf/struck-01/cavity_unparked',
            'bessy/rf/struck-01/cavity_being_parked',
            'bessy/rf/struck-01/cavity_being_unparked',
            'bessy/rf/struck-01/HW_Stop_in',
            'bessy/rf/struck-01/HW_Stop_out',
            'bessy/rf/struck-01/HW_Stop_in_delay',
            'bessy/rf/struck-01/HW_Stop_out_out',
            'bessy/rf/struck-01/adac_trig_nolatch',
            'bessy/rf/struck-01/adac_trig_delay',
            'bessy/rf/struck-01/FDL_Trg',
            'bessy/rf/struck-01/gpio_dinMSB',
            'bessy/rf/struck-01/gpio_din_LSBs',
            'bessy/rf/struck-01/gpio_dout_LSB',
            'bessy/rf/struck-01/gpio_dout_MSB',
            'bessy/rf/struck-01/AmpFwCircOutInit',
            'bessy/rf/struck-01/PhaseFwCircOutInit',
            'bessy/rf/struck-01/AmpControl1',
            'bessy/rf/struck-01/PhaseControl1',
            'bessy/rf/struck-01/AmpRampInitCav',
            'bessy/rf/struck-01/PhaseRampInitCav',
            'bessy/rf/struck-01/AmpRvSSA2',
            'bessy/rf/struck-01/PhaseRvSSA2',
            'bessy/rf/struck-01/AmpFwIOT1_PhSh',
            'bessy/rf/struck-01/PhaseFwIOT1_PhSh',
            'bessy/rf/struck-01/AmpFwInit',
            'bessy/rf/struck-01/PhaseFwInit',
            'bessy/rf/struck-01/AmpRvSSA1',
            'bessy/rf/struck-01/PhaseRvSSA1',
            'bessy/rf/struck-01/AmpRvCircOutEnd',
            'bessy/rf/struck-01/PhaseRvCircOutEnd',
            'bessy/rf/struck-01/AmpFwCav_PhSh',
            'bessy/rf/struck-01/PhaseFwCav_PhSh',
            'bessy/rf/struck-01/AmpRampEndCav',
            'bessy/rf/struck-01/PhaseRampEndCav',
            'bessy/rf/struck-01/AmpRampEndError',
            'bessy/rf/struck-01/PhaseRampEndError',
            'bessy/rf/struck-01/AmpRvCavEnd',
            'bessy/rf/struck-01/PhaseRvCavEnd',
            'bessy/rf/struck-01/AmpFwSSA2',
            'bessy/rf/struck-01/PhaseFwSSA2',
            'bessy/rf/struck-01/AmpFwLoadInit',
            'bessy/rf/struck-01/PhaseFwLoadInit',
            'bessy/rf/struck-01/AmpFwIOT2_PhSh',
            'bessy/rf/struck-01/PhaseFwIOT2_PhSh',
            'bessy/rf/struck-01/AmpFwCircIn',
            'bessy/rf/struck-01/PhaseFwCircIn',
            'bessy/rf/struck-01/AmpRampInitControl',
            'bessy/rf/struck-01/PhaseRampInitControl',
            'bessy/rf/struck-01/AmpRampInitError',
            'bessy/rf/struck-01/PhaseRampInitError',
            'bessy/rf/struck-01/AmpRvCircIn',
            'bessy/rf/struck-01/PhaseRvCircIn',
            'bessy/rf/struck-01/AmpRampEndErrorAccum',
            'bessy/rf/struck-01/PhaseRampEndErrorAccum',
            'bessy/rf/struck-01/AmpRampEndControl',
            'bessy/rf/struck-01/PhaseRampEndControl',
            'bessy/rf/struck-01/AmpFwLoadEnd',
            'bessy/rf/struck-01/PhaseFwLoadEnd',
            'bessy/rf/struck-01/AmpCell4End',
            'bessy/rf/struck-01/PhaseCell4End',
            'bessy/rf/struck-01/AmpRvIOT2',
            'bessy/rf/struck-01/PhaseRvIOT2',
            'bessy/rf/struck-01/AmpControl2',
            'bessy/rf/struck-01/PhaseControl2',
            'bessy/rf/struck-01/AmpRvCircOutInit',
            'bessy/rf/struck-01/PhaseRvCircOutInit',
            'bessy/rf/struck-01/AmpFwSSA1',
            'bessy/rf/struck-01/PhaseFwSSA1',
            'bessy/rf/struck-01/AmpRvCircOut',
            'bessy/rf/struck-01/PhaseRvCircOut',
            'bessy/rf/struck-01/AmpRampEndRef',
            'bessy/rf/struck-01/PhaseRampEndRef',
            'bessy/rf/struck-01/AmpCell2Init',
            'bessy/rf/struck-01/PhaseCell2Init',
            'bessy/rf/struck-01/AmpErrorAccum1',
            'bessy/rf/struck-01/PhaseErrorAccum1',
            'bessy/rf/struck-01/AmpRampInitErrorAccum',
            'bessy/rf/struck-01/PhaseRampInitErrorAccum',
            'bessy/rf/struck-01/AmpFwCircOutEnd',
            'bessy/rf/struck-01/PhaseFwCircOutEnd',
            'bessy/rf/struck-01/Amperror1',
            'bessy/rf/struck-01/Phaseerror1',
            'bessy/rf/struck-01/AmpRvCircInEnd',
            'bessy/rf/struck-01/PhaseRvCircInEnd',
            'bessy/rf/struck-01/AmpFwEnd',
            'bessy/rf/struck-01/PhaseFwEnd',
            'bessy/rf/struck-01/AmpFwCircOut',
            'bessy/rf/struck-01/PhaseFwCircOut',
            'bessy/rf/struck-01/AmpFwTx1End',
            'bessy/rf/struck-01/PhaseFwTx1End',
            'bessy/rf/struck-01/AmpRvTx1End',
            'bessy/rf/struck-01/PhaseRvTx1End',
            'bessy/rf/struck-01/AmpCell4Init',
            'bessy/rf/struck-01/PhaseCell4Init',
            'bessy/rf/struck-01/AmpRvIOT1',
            'bessy/rf/struck-01/PhaseRvIOT1',
            'bessy/rf/struck-01/AmpFwLoad',
            'bessy/rf/struck-01/PhaseFwLoad',
            'bessy/rf/struck-01/AmpCell2End',
            'bessy/rf/struck-01/PhaseCell2End',
            'bessy/rf/struck-01/AmpRvCircInInit',
            'bessy/rf/struck-01/PhaseRvCircInInit',
            'bessy/rf/struck-01/AmpRampInitRef',
            'bessy/rf/struck-01/PhaseRampInitRef',
        ],
        'DC': [
            'bessy/rf/struck-01/kp',
            'bessy/rf/struck-01/ki',
            'bessy/rf/struck-01/PhShCav',
            'bessy/rf/struck-01/PILimit',
            'bessy/rf/struck-01/Command_Start',
            'bessy/rf/struck-01/AmpRefCav',
            'bessy/rf/struck-01/PhRefCav',
            'bessy/rf/struck-01/AmpRefMin',
            'bessy/rf/struck-01/PhRefMin',
            'bessy/rf/struck-01/loop_enable',
            'bessy/rf/struck-01/Voltage_Increase_Rate',
            'bessy/rf/struck-01/Disable_RFON_ITCK_from_EPS',
            'bessy/rf/struck-01/Phase_Increase_Rate',
            'bessy/rf/struck-01/GPIO_inversion_LSBs',
            'bessy/rf/struck-01/GPIO_inversion_MSBs',
            'bessy/rf/struck-01/Conditioning_enable',
            'bessy/rf/struck-01/ConditioningDuty_Cicle',
            'bessy/rf/struck-01/UpdateDiag',
            'bessy/rf/struck-01/EPS_ITCK_Delay',
        ],
        'Tunning': [
            'bessy/rf/struck-01/Tuning_Enable1',
            'bessy/rf/struck-01/Tuning_Pos_En1',
            'bessy/rf/struck-01/Num_Steps1',
            'bessy/rf/struck-01/CLK_Per_Pulse1',
            'bessy/rf/struck-01/Phase_Offset',
            'bessy/rf/struck-01/MoveUp1',
            'bessy/rf/struck-01/MovePlg1',
            'bessy/rf/struck-01/TuningReset',
            'bessy/rf/struck-01/FwMin',
            'bessy/rf/struck-01/MarginUp',
            'bessy/rf/struck-01/MarginLow',
            'bessy/rf/struck-01/High_Vacuum_Interlock_Activated',
            'bessy/rf/struck-01/Low_vacuum_interlock_activated',
            'bessy/rf/struck-01/TuningDephaseInit',
            'bessy/rf/struck-01/TuningDephaseEnd',
            'bessy/rf/struck-01/PLG_Moving_Manual',
            'bessy/rf/struck-01/PLG_Moving_Auto',
        ],
        'VCXO': [
            'bessy/rf/struck-01/VCXO_Outputs_enable',
            'bessy/rf/struck-01/M_Divider',
            'bessy/rf/struck-01/N_divider',
            'bessy/rf/struck-01/MuxSel',
            'bessy/rf/struck-01/Mux0_Divider',
            'bessy/rf/struck-01/Mux1_Divider',
            'bessy/rf/struck-01/Mux2_Divider',
            'bessy/rf/struck-01/Mux3_Divider',
            'bessy/rf/struck-01/Mux4_Divider',
            'bessy/rf/struck-01/Send_Word',
            'bessy/rf/struck-01/CP_Dir',
            'bessy/rf/struck-01/VCXO_Output_inversion',
            'bessy/rf/struck-01/Y0Enable',
            'bessy/rf/struck-01/Y1Enable',
            'bessy/rf/struck-01/Y2Enable',
            'bessy/rf/struck-01/Y3Enable',
            'bessy/rf/struck-01/Y4Enable',
        ],
        'Diag_Matrix': [
            'bessy/rf/struck-01/Icav1',
            'bessy/rf/struck-01/Qcav1',
            'bessy/rf/struck-01/IControl',
            'bessy/rf/struck-01/QControl',
            'bessy/rf/struck-01/IFw1',
            'bessy/rf/struck-01/QFw1',
            'bessy/rf/struck-01/Iref1',
            'bessy/rf/struck-01/Qref1',
            'bessy/rf/struck-01/IFwDrive',
            'bessy/rf/struck-01/QFwDrive',
            'bessy/rf/struck-01/IFwSSPA',
            'bessy/rf/struck-01/QFwSSPA',
            'bessy/rf/struck-01/IRF6',
            'bessy/rf/struck-01/QRF6',
            'bessy/rf/struck-01/IRvCav',
            'bessy/rf/struck-01/QRvCav',
            'bessy/rf/struck-01/IMO',
            'bessy/rf/struck-01/QMO',
            'bessy/rf/struck-01/IFwTx1',
            'bessy/rf/struck-01/QFwTx1',
            'bessy/rf/struck-01/DC_input_1',
            'bessy/rf/struck-01/DC_input_2',
            'bessy/rf/struck-01/AmpMO',
            'bessy/rf/struck-01/PhaseMO',
            'bessy/rf/struck-01/ILoopInput',
            'bessy/rf/struck-01/QLoopInput',
            'bessy/rf/struck-01/AmpLoopInput',
            'bessy/rf/struck-01/AmpFwDrive',
            'bessy/rf/struck-01/PhaseFwDrive',
            'bessy/rf/struck-01/AmpRF6',
            'bessy/rf/struck-01/PhaseRF6',
            'bessy/rf/struck-01/Ampcav1',
            'bessy/rf/struck-01/Phasecav1',
            'bessy/rf/struck-01/AmpRvCav',
            'bessy/rf/struck-01/PhaseRvCav',
            'bessy/rf/struck-01/AmpControl',
            'bessy/rf/struck-01/PhaseControl',
            'bessy/rf/struck-01/AmpFw1',
            'bessy/rf/struck-01/PhaseFw1',
            'bessy/rf/struck-01/AmpFwTx1',
            'bessy/rf/struck-01/PhaseFwTx1',
            'bessy/rf/struck-01/Ampref1',
            'bessy/rf/struck-01/Phaseref1',
            'bessy/rf/struck-01/PhaseLoopInput',
            'bessy/rf/struck-01/AmpFwSSPA',
            'bessy/rf/struck-01/PhaseFwSSPA',
        ],
    }
    for panel_name in panels:
        panel = DllrfPanel(withButtons=False)
        panel.setModel(panels[panel_name])
        gui.createPanel(panel, panel_name)
    panel = TaurusTrend()
    gui.createPanel(panel, "Trend")
    if 'default' in gui.getPerspectivesList():
        gui.loadPerspective(name='default')
    gui.show()
    app.exec_()


if __name__ == '__main__':
    main()

